"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var react_native_svg_1 = require("react-native-svg");
var config_1 = require("../../config");
var BUTTON_SIZE = 40;
var CIRCLE_SIZE = BUTTON_SIZE / 2;
var ICON_SIZE = BUTTON_SIZE / 2;
var CircleButton = function (_a) {
    var onPress = _a.onPress, src = _a.src, text = _a.text, disabled = _a.disabled, color = _a.color, colorDisabled = _a.colorDisabled, circleColor = _a.circleColor;
    return (react_1.default.createElement(react_native_1.TouchableOpacity, { style: [
            styles.button,
            disabled
                ? { backgroundColor: colorDisabled !== null && colorDisabled !== void 0 ? colorDisabled : 'black' }
                : { backgroundColor: color !== null && color !== void 0 ? color : 'black' },
        ], disabled: disabled, onPress: onPress },
        react_1.default.createElement(react_native_svg_1.SvgUri, { uri: src, fill: config_1.Config.DEFAULT_BG_COLOR, width: ICON_SIZE, height: ICON_SIZE }),
        text && (react_1.default.createElement(react_native_1.View, { style: [
                styles.circle,
                { backgroundColor: circleColor !== null && circleColor !== void 0 ? circleColor : 'black' },
            ] },
            react_1.default.createElement(react_native_1.Text, { style: styles.text }, text)))));
};
var styles = react_native_1.StyleSheet.create({
    button: {
        width: BUTTON_SIZE,
        height: BUTTON_SIZE,
        borderRadius: BUTTON_SIZE / 2,
        justifyContent: 'center',
        alignItems: 'center',
        backgroundColor: 'black',
    },
    circle: {
        width: CIRCLE_SIZE,
        height: CIRCLE_SIZE,
        position: 'absolute',
        borderRadius: CIRCLE_SIZE / 2,
        right: -10,
        top: CIRCLE_SIZE,
        alignItems: 'center',
        justifyContent: 'center',
        borderWidth: 1,
        borderColor: 'white',
    },
    text: {
        color: 'white',
        fontSize: 11,
    },
});
exports.default = CircleButton;
