"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var react_native_svg_1 = require("react-native-svg");
var config_1 = require("../../../config");
var Row_1 = __importDefault(require("../Row"));
var FloorModal = function (_a) {
    var floors = _a.floors, expanded = _a.expanded, closeModal = _a.closeModal, onFloorChanged = _a.onFloorChanged, _b = _a.floorText, floorText = _b === void 0 ? '' : _b;
    return (react_1.default.createElement(react_native_1.Modal, { transparent: true, visible: expanded },
        react_1.default.createElement(react_native_1.SafeAreaView, { style: styles.safeArea },
            react_1.default.createElement(react_native_1.View, { style: styles.dropdown },
                react_1.default.createElement(react_native_1.TouchableOpacity, { style: styles.closeWrapper, onPress: closeModal },
                    react_1.default.createElement(react_native_svg_1.SvgUri, { uri: String(config_1.Config.CLOSE_ICON), fill: config_1.Config.DEFAULT_BG_COLOR, width: config_1.Config.RESET_SIZE, height: config_1.Config.RESET_SIZE, style: styles.close })),
                react_1.default.createElement(react_native_1.ScrollView, { style: styles.rowWrapper, contentContainerStyle: styles.scrollContent }, floors === null || floors === void 0 ? void 0 : floors.map(function (floor) { return (react_1.default.createElement(Row_1.default, { key: floor === null || floor === void 0 ? void 0 : floor.floor, text: "".concat(floorText, " ").concat(floor === null || floor === void 0 ? void 0 : floor.floor), floorId: floor === null || floor === void 0 ? void 0 : floor.floor, onFloorChanged: onFloorChanged, closeModal: closeModal })); }))))));
};
var styles = react_native_1.StyleSheet.create({
    safeArea: {
        flex: 1,
        backgroundColor: 'rgba(0, 0, 0, .8)',
    },
    dropdown: {
        width: '100%',
        height: '70%',
    },
    closeWrapper: {
        width: '100%',
        alignItems: 'flex-end',
    },
    close: {
        marginRight: 20,
        marginBottom: 20,
        color: 'white',
    },
    rowWrapper: {
        flex: 1,
    },
    scrollContent: {
        alignItems: 'center',
    },
});
exports.default = FloorModal;
