"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var Floors_1 = __importDefault(require("../Floors"));
var Spacer_1 = __importDefault(require("../Spacer"));
var Zoom_1 = __importDefault(require("../Zoom"));
var Header = function (_a) {
    var zoom = _a.zoom, mapUrls = _a.mapUrls, floor = _a.floor, setZoom = _a.setZoom, onZoomReset = _a.onZoomReset, setFloor = _a.setFloor, _b = _a.showHeader, showHeader = _b === void 0 ? true : _b, zoomOptions = _a.zoomOptions, floorText = _a.floorText, allowFloorDropdown = _a.allowFloorDropdown, showFloors = _a.showFloors, _c = _a.alignment, alignment = _c === void 0 ? 'center' : _c, headerOnRight = _a.headerOnRight, floorButtonColor = _a.floorButtonColor, floorCircleColor = _a.floorCircleColor, buttonGap = _a.buttonGap;
    if (!showHeader)
        return react_1.default.createElement(react_1.default.Fragment, null);
    return (react_1.default.createElement(react_native_1.View, { style: [
            styles.actionWrapper,
            {
                justifyContent: alignment,
                alignSelf: headerOnRight
                    ? 'flex-end'
                    : 'flex-start',
            },
        ] },
        !(zoomOptions === null || zoomOptions === void 0 ? void 0 : zoomOptions.hideZoom) && (react_1.default.createElement(Zoom_1.default, { zoom: zoom, onZoomChanged: function (value) { return setZoom(value); }, maxZoom: zoomOptions === null || zoomOptions === void 0 ? void 0 : zoomOptions.maxZoom, zoomStyle: zoomOptions === null || zoomOptions === void 0 ? void 0 : zoomOptions.zoomStyle, sensitivity: zoomOptions === null || zoomOptions === void 0 ? void 0 : zoomOptions.sensitivity, showResetButton: zoomOptions === null || zoomOptions === void 0 ? void 0 : zoomOptions.showResetButton, onReset: onZoomReset, hideZoom: zoomOptions === null || zoomOptions === void 0 ? void 0 : zoomOptions.hideZoom, zoomColor: zoomOptions === null || zoomOptions === void 0 ? void 0 : zoomOptions.zoomColor, zoomDisabledColor: zoomOptions === null || zoomOptions === void 0 ? void 0 : zoomOptions.zoomDisabledColor, circleColor: zoomOptions === null || zoomOptions === void 0 ? void 0 : zoomOptions.circleColor, buttonGap: buttonGap })),
        react_1.default.createElement(Spacer_1.default, { vertical: true, gap: buttonGap !== null && buttonGap !== void 0 ? buttonGap : 4 }),
        react_1.default.createElement(Floors_1.default, { floors: mapUrls, currentFloor: floor, onFloorChanged: function (newFloor) {
                setFloor(newFloor);
                !(zoomOptions === null || zoomOptions === void 0 ? void 0 : zoomOptions.preventReset) && onZoomReset();
            }, floorText: floorText, allowDropdown: allowFloorDropdown, showFloors: showFloors, buttonColor: floorButtonColor, circleColor: floorCircleColor }),
        react_1.default.createElement(Spacer_1.default, { vertical: true, gap: buttonGap !== null && buttonGap !== void 0 ? buttonGap : 4 })));
};
var styles = react_native_1.StyleSheet.create({
    actionWrapper: {
        height: '100%',
        alignItems: 'center',
        position: 'absolute',
        zIndex: 999999,
        paddingHorizontal: 12,
        alignSelf: 'flex-start',
    },
});
exports.default = Header;
