"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var react_native_svg_1 = require("react-native-svg");
var config_1 = require("../../config");
var Marker = function (_a) {
    var _b, _c, _d;
    var value = _a.value, width = _a.width, height = _a.height, x = _a.x, y = _a.y, text = _a.text, textStyle = _a.textStyle, markerStyle = _a.markerStyle, onPress = _a.onPress, textDelay = _a.textDelay, color = _a.color, iconUrl = _a.iconUrl, isStairs = _a.isStairs, iconSize = _a.iconSize, iconColor = _a.iconColor, iconRotate = _a.iconRotate;
    var DEFAULT_BG_COLOR = config_1.Config.DEFAULT_BG_COLOR, DEFAULT_TEXTCOLOR = config_1.Config.DEFAULT_TEXTCOLOR, DEFAULT_MARKER_COLOR = config_1.Config.DEFAULT_MARKER_COLOR, STAIRS_ICON = config_1.Config.STAIRS_ICON;
    var _e = (0, react_1.useState)(false), visible = _e[0], setVisible = _e[1];
    (0, react_1.useEffect)(function () {
        if (visible) {
            setTimeout(function () {
                setVisible(false);
            }, textDelay !== null && textDelay !== void 0 ? textDelay : 5000);
        }
    }, [textDelay, visible]);
    var onMarkerPress = function () {
        if (onPress) {
            onPress(value);
        }
        setVisible(true);
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        visible && text && (react_1.default.createElement(react_native_1.View, { style: [
                styles.textWrapper,
                {
                    transform: [
                        { translateX: x },
                        { translateY: y - 15 },
                    ],
                    backgroundColor: (_b = textStyle === null || textStyle === void 0 ? void 0 : textStyle.backgroundColor) !== null && _b !== void 0 ? _b : DEFAULT_BG_COLOR,
                },
            ] },
            react_1.default.createElement(react_native_1.Text, { style: {
                    fontSize: (_c = textStyle === null || textStyle === void 0 ? void 0 : textStyle.fontSize) !== null && _c !== void 0 ? _c : 8,
                    color: (_d = textStyle === null || textStyle === void 0 ? void 0 : textStyle.textColor) !== null && _d !== void 0 ? _d : DEFAULT_TEXTCOLOR,
                } }, text))),
        react_1.default.createElement(react_native_1.TouchableOpacity, { style: [
                styles.marker,
                {
                    width: width,
                    height: height,
                    transform: [
                        { translateX: x },
                        { translateY: y },
                    ],
                    backgroundColor: color !== null && color !== void 0 ? color : DEFAULT_MARKER_COLOR,
                },
                markerStyle,
            ], onPress: onMarkerPress },
            react_1.default.createElement(react_native_svg_1.SvgUri, { uri: isStairs ? String(STAIRS_ICON) : iconUrl, style: [
                    styles.markerIcon,
                    {
                        width: iconSize,
                        height: iconSize,
                        transform: [{ rotate: "".concat(iconRotate, "deg") }],
                    },
                ], fill: iconColor !== null && iconColor !== void 0 ? iconColor : 'black' }))));
};
var styles = react_native_1.StyleSheet.create({
    marker: {
        width: 3,
        height: 3,
        position: 'absolute',
        justifyContent: 'center',
        alignItems: 'center',
    },
    textWrapper: {
        position: 'absolute',
        padding: 4,
        borderRadius: 4,
        zIndex: 30000,
    },
    markerIcon: {
        zIndex: 3000,
    },
});
exports.default = Marker;
