"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var config_1 = require("../../config");
var CircleButton_1 = __importDefault(require("../CircleButton"));
var Spacer_1 = __importDefault(require("../Spacer"));
var Zoom = function (_a) {
    var onZoomChanged = _a.onZoomChanged, onReset = _a.onReset, _b = _a.zoom, zoom = _b === void 0 ? 1 : _b, maxZoom = _a.maxZoom, _c = _a.sensitivity, sensitivity = _c === void 0 ? 1 : _c, showResetButton = _a.showResetButton, hideZoom = _a.hideZoom, zoomColor = _a.zoomColor, zoomDisabledColor = _a.zoomDisabledColor, circleColor = _a.circleColor, buttonGap = _a.buttonGap;
    var disabledPlus = maxZoom
        ? zoom >= maxZoom + 1
        : undefined;
    var disabledNegative = zoom <= 1;
    if (hideZoom)
        return react_1.default.createElement(react_1.default.Fragment, null);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(CircleButton_1.default, { onPress: function () { return onZoomChanged(zoom + sensitivity); }, src: String(config_1.Config.ZOOM_PLUS_ICON), disabled: disabledPlus, color: zoomColor, colorDisabled: zoomDisabledColor, circleColor: circleColor }),
        react_1.default.createElement(Spacer_1.default, { gap: buttonGap !== null && buttonGap !== void 0 ? buttonGap : 4, vertical: true }),
        react_1.default.createElement(CircleButton_1.default, { onPress: function () { return onZoomChanged(zoom - sensitivity); }, src: String(config_1.Config.ZOOM_MINUS_ICON), disabled: disabledNegative, color: zoomColor, colorDisabled: zoomDisabledColor, circleColor: circleColor }),
        showResetButton && zoom > 1 && (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(Spacer_1.default, { gap: buttonGap !== null && buttonGap !== void 0 ? buttonGap : 4, vertical: true }),
            react_1.default.createElement(CircleButton_1.default, { onPress: onReset, src: String(config_1.Config.RESET_ICON), disabled: disabledPlus, color: zoomColor, colorDisabled: zoomDisabledColor, circleColor: circleColor })))));
};
exports.default = Zoom;
