"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var react_native_svg_1 = require("react-native-svg");
var Marker_1 = __importDefault(require("./components/Marker"));
var config_1 = require("./config");
var Header_1 = __importDefault(require("./components/Header"));
var Map = function (_a) {
    var _b, _c, _d, _e, _f, _g, _h;
    var mapUrls = _a.mapUrls, _j = _a.floor, floor = _j === void 0 ? 0 : _j, setFloor = _a.setFloor, mapStyle = _a.mapStyle, header = _a.header, onMarkerPress = _a.onMarkerPress;
    var DEFAULT_ZOOM = config_1.Config.DEFAULT_ZOOM, DEFAULT_MAP_SIZE = config_1.Config.DEFAULT_MAP_SIZE;
    var findFloor = function () {
        var _a;
        return (_a = mapUrls === null || mapUrls === void 0 ? void 0 : mapUrls.find(function (obj) { return obj.floor === floor; })) !== null && _a !== void 0 ? _a : mapUrls[0];
    };
    var _k = (0, react_1.useState)((_c = (_b = header === null || header === void 0 ? void 0 : header.zoomOptions) === null || _b === void 0 ? void 0 : _b.zoom) !== null && _c !== void 0 ? _c : DEFAULT_ZOOM), zoom = _k[0], setZoom = _k[1];
    var pan = (0, react_1.useRef)(new react_native_1.Animated.ValueXY()).current;
    var panResponder = (0, react_1.useRef)(react_native_1.PanResponder.create({
        onMoveShouldSetPanResponder: function () { return true; },
        onPanResponderGrant: function () {
            pan.setOffset({
                x: pan.x._value,
                y: pan.y._value,
            });
        },
        onPanResponderMove: react_native_1.Animated.event([null, { dx: pan.x, dy: pan.y }], { useNativeDriver: false }),
        onPanResponderRelease: function () {
            pan.flattenOffset();
        },
    })).current;
    var resetZoom = function () {
        setZoom(DEFAULT_ZOOM);
        pan.setValue({ x: 0, y: 0 });
    };
    return (react_1.default.createElement(react_native_1.View, { style: styles.wrapper },
        react_1.default.createElement(Header_1.default, { floor: floor, mapUrls: mapUrls, onZoomReset: resetZoom, setFloor: setFloor, setZoom: setZoom, zoom: zoom, allowFloorDropdown: header === null || header === void 0 ? void 0 : header.allowFloorDropdown, floorText: header === null || header === void 0 ? void 0 : header.floorText, showHeader: header === null || header === void 0 ? void 0 : header.showHeader, showFloors: header === null || header === void 0 ? void 0 : header.showFloors, zoomOptions: header === null || header === void 0 ? void 0 : header.zoomOptions, alignment: header === null || header === void 0 ? void 0 : header.alignment, headerOnRight: header === null || header === void 0 ? void 0 : header.headerOnRight, floorButtonColor: header === null || header === void 0 ? void 0 : header.floorButtonColor, floorCircleColor: header === null || header === void 0 ? void 0 : header.floorCircleColor, buttonGap: header === null || header === void 0 ? void 0 : header.buttonGap }),
        react_1.default.createElement(react_native_1.View, { style: [
                styles.outerMapPart,
                { backgroundColor: mapStyle === null || mapStyle === void 0 ? void 0 : mapStyle.backgroundColor },
            ] },
            react_1.default.createElement(react_native_1.Animated.View, __assign({ style: [
                    styles.innerMapPart,
                    {
                        width: (_d = mapStyle === null || mapStyle === void 0 ? void 0 : mapStyle.size) !== null && _d !== void 0 ? _d : DEFAULT_MAP_SIZE,
                        height: (_e = mapStyle === null || mapStyle === void 0 ? void 0 : mapStyle.size) !== null && _e !== void 0 ? _e : DEFAULT_MAP_SIZE,
                        transform: [
                            { translateX: pan.x },
                            { translateY: pan.y },
                            { scale: zoom },
                        ],
                        backgroundColor: mapStyle === null || mapStyle === void 0 ? void 0 : mapStyle.mapBackgroundColor,
                    },
                ] }, panResponder.panHandlers),
                react_1.default.createElement(react_native_svg_1.SvgUri, { uri: (_f = findFloor()) === null || _f === void 0 ? void 0 : _f.url, fill: "black" }), (_h = (_g = findFloor()) === null || _g === void 0 ? void 0 : _g.markers) === null || _h === void 0 ? void 0 :
                _h.map(function (marker, index) { return (react_1.default.createElement(Marker_1.default, { key: marker.value + index, text: marker === null || marker === void 0 ? void 0 : marker.text, value: marker === null || marker === void 0 ? void 0 : marker.value, width: marker === null || marker === void 0 ? void 0 : marker.width, height: marker === null || marker === void 0 ? void 0 : marker.height, x: marker === null || marker === void 0 ? void 0 : marker.x, y: marker === null || marker === void 0 ? void 0 : marker.y, onPress: onMarkerPress, textDelay: marker === null || marker === void 0 ? void 0 : marker.textDelay, color: marker === null || marker === void 0 ? void 0 : marker.color, isStairs: marker === null || marker === void 0 ? void 0 : marker.isStairs, iconUrl: marker === null || marker === void 0 ? void 0 : marker.iconUrl, iconSize: marker === null || marker === void 0 ? void 0 : marker.iconSize, iconColor: marker === null || marker === void 0 ? void 0 : marker.iconColor, iconRotate: marker === null || marker === void 0 ? void 0 : marker.iconRotate })); })))));
};
var styles = react_native_1.StyleSheet.create({
    safeArea: {
        flex: 1,
        marginHorizontal: 8,
    },
    wrapper: {
        flex: 1,
    },
    outerMapPart: {
        flex: 1,
        overflow: 'hidden',
        justifyContent: 'center',
        alignItems: 'center',
    },
    innerMapPart: {
        zIndex: -1,
        justifyContent: 'center',
        alignItems: 'center',
    },
});
exports.default = Map;
