import { ViewStyle } from "react-native";
export declare type MapProps = {
    size?: number;
    backgroundColor?: string;
    mapBackgroundColor?: string;
};
export declare type TextStyle = {
    backgroundColor: string;
    textColor: string;
    fontSize: number;
};
export declare type MarkerProps = {
    value: string;
    width: number;
    height: number;
    x: number;
    y: number;
    text?: string;
    textStyle?: TextStyle;
    markerStyle?: ViewStyle;
    textDelay?: number;
    color?: string;
    iconUrl?: string;
    isStairs?: boolean;
    iconSize?: number;
    iconColor?: string;
    iconRotate?: number;
};
export declare type FloorProps = {
    url: string;
    floor: number;
    markers?: MarkerProps[];
};
export declare type ZoomProps = {
    zoom?: number;
    maxZoom?: number;
    zoomStyle?: ViewStyle;
    hideZoom?: boolean;
    sensitivity?: number;
    showResetButton?: boolean;
    resetIconUri?: string;
    zoomColor?: string;
    zoomDisabledColor?: string;
    preventReset?: boolean;
    circleColor?: string;
};
export declare type HeaderProps = {
    showHeader?: boolean;
    zoomOptions?: ZoomProps;
    floorText?: string;
    allowFloorDropdown?: boolean;
    showFloors?: boolean;
    alignment?: "flex-start" | "center" | "flex-end";
    headerOnRight?: boolean;
    floorButtonColor?: string;
    floorCircleColor?: string;
    buttonGap?: number;
};
